<?php
# This file was automatically generated by the MediaWiki 1.18.1
# installer. If you make manual changes, please keep track in case you
# need to recreate them later.
#
# See includes/DefaultSettings.php for all configurable settings
# and their default values, but don't forget to make changes in _this_
# file, not there.
#
# Further documentation for configuration settings may be found at:
# http://www.mediawiki.org/wiki/Manual:Configuration_settings

# Protect against web entry
if ( !defined( 'MEDIAWIKI' ) ) {
	exit;
}

## Uncomment this to disable output compression
# $wgDisableOutputCompression = true;

$wgSitename = "Wikimedia Italia";

## The URL base path to the directory containing the wiki;
## defaults for all runtime URL paths are based off of this.
## For more information on customizing the URLs please see:
## http://www.mediawiki.org/wiki/Manual:Short_URL
$wgScriptPath = "";
$wgScriptExtension = ".php";

#Short URL
#$wgScriptPath = "/w"; # in default installations this line is already present. /w stands for the actual existing folder with the mediawiki-installation.
$wgScriptPath = ""; # in default installations this line is already present. /w stands for the actual existing folder with the mediawiki-installation.
$wgScript = "$wgScriptPath/index.php";
$wgArticlePath = "/wiki/$1";  # /wiki stands for the desired URL that you wish to use for accessing the mediawiki-content.
$wgUsePathInfo = true;

## The protocol and server name to use in fully-qualified URLs
$wgServer           = "//wiki.wikimedia.it";
$wgCanonicalServer  = "https://wiki.wikimedia.it";
$wgEnableCanonicalServerLink = true;
$wgSecureLogin      = true;

## The relative URL path to the skins directory
$wgStylePath        = "$wgScriptPath/skins";

## The relative URL path to the logo.  Make sure you change this from the default,
## or else you'll overwrite your logo when you upgrade!
#$wgLogo             = "$wgStylePath/common/images/wiki.png";

## UPO means: this is also a user preference option

$wgEnableEmail      = true;
$wgEnableUserEmail  = true; # UPO

// The email contacts are saved in LocalSettings-secret.php in the parent directory
//$wgEmergencyContact = "<omissis>";
//$wgPasswordSender   = "<omissis>";

$wgEnotifUserTalk      = true; # UPO
$wgEnotifWatchlist     = true; # UPO
$wgEmailAuthentication = true;
$wgDefaultUserOptions['enotifwatchlistpages'] = 1;
$wgDefaultUserOptions['watchdefault'] = 1;
$wgDefaultUserOptions['extendwatchlist'] = 1;
$wgGroupPermissions['user']['unwatchedpages'] = true;

# Alla creazione di una nuova utenza, aggiungi pagine importanti alla
# lista degli osservati speciali. I più se le perdono.
// @deprecated since 1.27.0
// https://www.mediawiki.org/wiki/Manual:Hooks/AddNewAccount
//$wgHooks['AddNewAccount'][] = function ( User $user, $altroInutile ) {
/*
$wgHooks['LocalUserCreated'][] = function ( User $user, $altroInutile ) {
	$aggiornamentiImportanti = array (
		'Associazione:Pagina principale',
		'Associazione:Bar',
		'Associazione:Delibere',
		'Diario di bordo',
		'Associazione:Riunioni del Direttivo',
		// 2021-10-06: rimossa pagina datata
		//'Associazione:Cosa bolle in pentola',
	);
	foreach( $aggiornamentiImportanti as $pagina ) {
		$titolo = Title::newFromText( $pagina );
		if( $titolo ) {

			// @deprecated since 1.37
			// «The User class methods ::isWatched(), ::isTempWatched(), ::removeWatch(), and ::addWatch() have been deprecated. Use corresponding methods in WatchlistManager instead.»
			// https://www.mediawiki.org/wiki/Release_notes/1.37
			$user->addWatch( $titolo, WatchedItem::IGNORE_USER_RIGHTS );
		}
	}
};
*/

/* Riprendi possesso di un'utenza compromessa */
/*
$wgHooks['UserEffectiveGroups'][] = function ( &$user, &$aUserGroups ) {
	if ( $user->getName() == 'Pinco Pallo' ) {
		$aUserGroups = '*';
		return false;
	}
};
$wgHooks['AbortLogin'][] = function ( $user, $password, &$retval, &$msg ) {
	if ( $user->getName() == 'Pinco Pallo' ) {
		// $user->setEmailWithConfirmation( 'panco.pillo@wikimedia.it' );
		$user->setPassword( null );
		return false;
	}
};
*/

## Database settings
$wgDBtype           = "mysql";
$wgDBserver         = "localhost";
$wgDBname           = "wikina";

// The database credentials are saved in LocalSettings-secret.php in the parent directory
//$wgDBuser           = 'omissis';
//$wgDBpassword       = 'omissis';

# MySQL specific settings
$wgDBprefix         = "";

# MySQL table options to use during installation or update
$wgDBTableOptions   = "ENGINE=InnoDB, DEFAULT CHARSET=utf8";

// temporary directory dedicated to this MediaWiki installation
$wgTmpDirectory = "$IP/../tmp";

# Experimental charset support for MySQL 4.1/5.0.
$wgDBmysql5 = false;

## Shared memory settings
//$wgMainCacheType    = CACHE_ACCEL;
$wgMainCacheType    = CACHE_MEMCACHED;

// we do not use memcache
//$wgMemCachedServers = array();

// CACHE_ANYTHING è il valore predefinito; DB è lento, acceleratori non ne abbiamo.
// 2016-01-01 attivato ACCEL, ora abbiamo APC
//$wgParserCacheType = CACHE_ACCEL;
$wgParserCacheType = CACHE_MEMCACHED;
$wgRevisionCacheExpiry = 3*24*3600;
$wgParserCacheExpireTime = 14*24*3600;

# Sennò l'utente può aprire solo una pagina alla volta. Verificare OC funzioni!
# Indispensabile per caricare le bandierine in pagina principale in parallelo.
# 2021-02-25 disabilitato temporaneamente --Federico
# 2021-06-12 riabilitato --Federico
# 2022-07-25 config not available in MediaWiki anymore --Valerio Bozz
//$wgSessionsInObjectCache = true;

# http://wiki.wikimedia.it/index.php?oldid=270951#Perdita_dei_dati_di_sessione
// 2022: we have memcached
//$wgSessionCacheType = CACHE_DB;
$wgSessionCacheType = CACHE_MEMCACHED;

## Set $wgCacheDirectory to a writable directory on the web server
## to make your wiki go slightly faster. The directory should not
## be publically accessible from the web.
$wgCacheDirectory = "$IP/../cache";

// static HTML pages that are served to unregistered viewers to reduce database traffic
$wgUseFileCache = true;

//$wgUseLocalMessageCache = true;
//$wgMessageCacheType = CACHE_ACCEL;
$wgMessageCacheType = CACHE_MEMCACHED;

## Altre velocizzazioni
//$wgJobRunRate = 0.01; // Quasi zero ma non zero in caso non ci sia cronjob.
$wgJobRunRate = 0;      // Zero. Per identificare meglio i bug con il servizio (T325518)

# mod_deflate già attivato
# $wgUseGzip = true;
# Le pagine interne sono spesso visitate poche decine di volte. Ogni
# visita è contata comunque ma il conteggio visibile è aggiornato ogni tot:
# 2016-05-18 proviamo a disabilitare, non compare il numero sulle pagine nuove
# $wgHitcounterUpdateFreq = 10;

## To enable image uploads, make sure the 'images' directory
## is writable, then set this to true:
$wgUploadDirectory = "{$IP}/images";
$wgUploadPath= "{$wgScriptPath}/images";
$wgEnableUploads  = true;
$wgUseImageMagick = true;
$wgImageMagickConvertCommand = "/usr/bin/convert";
$wgPdfProcessor = '/usr/bin/gs';
$wgPdfPostProcessor = $wgImageMagickConvertCommand;
$wgPdfInfo = '/usr/bin/pdfinfo';
$wgPdftoText = '/usr/bin/pdftotext';

# KiB
# Neanche 512 MB bastano per [[File:Striscione_Wikipedia300x70_2logoC.pdf]]
$wgMaxShellMemory = 1024 * 1024;

// pixels
// fix "Error creating thumbnail: File with dimensions greater than 12.5MP"
// https://phabricator.wikimedia.org/T304203
$wgMaxImageArea = 4.9e7;

// KiB (default: 102400)
// fix "Unable to extend cache"
// https://phabricator.wikimedia.org/T304203
$wgMaxShellFileSize = 1024 * 500;

# InstantCommons allows wiki to use images from http://commons.wikimedia.org
// enabling Instant Commons again: since MediaWiki 1.29 local files are not used anymore
$wgUseInstantCommons  = true;

## If you use ImageMagick (or any other shell command) on a
## Linux server, this will need to be set to the name of an
## available UTF-8 locale
// fix wrong srcset="" with comma instead of "."
// https://phabricator.wikimedia.org/T181987
//$wgShellLocale = "it_IT.utf8";
$wgShellLocale = 'C.UTF-8';

## If you want to use image uploads under safe mode,
## create the directories images/archive, images/thumb and
## images/temp, and make them all writable. Then uncomment
## this, if it's not already uncommented:
# $wgHashedUploadDirectory = false;

# Site language code, should be one of the list in ./languages/Names.php
$wgLanguageCode = "it";

# Secret key
// https://www.mediawiki.org/wiki/Manual:$wgSecretKey
// this secret configuration is stored in the LocalSettings-secret.php
// $wgSecretKey = "<omissis>";

# Site upgrade key. Must be set to a string (default provided) to turn on the
# web installer while LocalSettings.php is in place
// this secret configuration is stored in the LocalSettings-secret.php
//$wgUpgradeKey = "<omissis>";

#### SKIN ####
wfLoadSkin( 'Vector' );
wfLoadSkin( 'MonoBook' );

#require_once "$IP/skins/MonoBook/MonoBook.php";
#require_once "$IP/skins/Vector/Vector.php";

## Default skin: you can change the default skin. Use the internal symbolic
## names, ie 'standard', 'nostalgia', 'cologneblue', 'monobook', 'vector':
$wgDefaultSkin = "vector";
$wgVectorResponsive = true;

## For attaching licensing metadata to pages, and displaying an
## appropriate copyright notice / icon. GNU Free Documentation
## License and Creative Commons licenses are supported so far.
$wgRightsPage = ""; # Set to the title of a wiki page that describes your license/copyright
$wgRightsUrl  = "https://creativecommons.org/licenses/by-sa/3.0/";
$wgRightsText = "Creative Commons Attribuzione-Condividi allo stesso modo";
$wgRightsIcon = "{$wgStylePath}/common/images/cc-by-sa.png";
# $wgRightsCode = ""; # Not yet used

# Path to the GNU diff3 utility. Used for conflict resolution.
$wgDiff3 = "/usr/bin/diff3";

# Query string length limit for ResourceLoader. You should only set this if
# your web server has a query string length limit (then set it to that limit),
# or if you have suhosin.get.max_value_length set in php.ini (then set it to
# that value)
$wgResourceLoaderMaxQueryLength = 1024;


# Enabled Extensions. Most extensions are enabled by including the base extension file here
# but check specific extension documentation for more details

wfLoadExtension( 'CharInsert' );
wfLoadExtension( 'Cite' );
#wfLoadExtension( 'ConfirmEdit' );
wfLoadExtension( 'EmbedVideo' );
wfLoadExtension( 'Gadgets' );
# wfLoadExtension( 'ImageMap' );
# 2016-08-07 riattivata su richiesta del presidente per le delibere:
wfLoadExtension( 'InputBox' );
wfLoadExtension( 'Interwiki' );
//wfLoadExtension( 'HitCounters' );
wfLoadExtension( 'Nuke' );
wfLoadExtension( 'ParserFunctions' );
//wfLoadExtension( 'Poem' ); // used in just one unuseful page
wfLoadExtension( 'PdfHandler' );
wfLoadExtension( 'Renameuser' );
# wfLoadExtension( 'SyntaxHighlight_GeSHi' );
wfLoadExtension( 'WikiEditor' );

// https://phabricator.wikimedia.org/T326654
wfLoadExtension( 'TemplateStyles' );

// https://phabricator.wikimedia.org/T326551
wfLoadExtension( 'TemplateSandbox' );

# End of automatically generated settings.
# Add more configuration options below.

# require_once "$IP/extensions/EmbedVideo/EmbedVideo.php";

// the Lockdown extension was migrated to $wgWhitelist
//require_once "$IP/extensions/Lockdown/Lockdown.php";

$wgBlockDisablesLogin = true;

// https://wiki.wikimedia.it/wiki/File:Favicon.gif
//$wgFavicon = "{$wgUploadPath}/3/3d/Favicon.gif";

// https://wiki.wikimedia.it/wiki/File:WMIT_Favicon.ico
$wgFavicon = "{$wgUploadPath}/e/e8/WMIT_Favicon.ico";

//$wgLogo = "{$wgUploadPath}/c/c9/Logo.png";
$wgLogo = "{$wgUploadPath}/6/62/Wikimedia_Italia-logo-black.png";

# Attiva i fogli di stile e i java script personali
$wgAllowUserCss = true;
$wgAllowUserJs = true;

# Velocizza CSS e JS
# http://www.webpagetest.org/result/151010_9D_DM9/1/performance_optimization/#cache_static_content
//$wgResourceLoaderMaxage['unversioned'] = array(
//	'server' => 30 * 24 * 3600, // 30 giorni
//	'client' => 30 * 24 * 3600, // 30 giorni
//);
$wgResourceLoaderMaxage['unversioned'] = 30 * 24 * 3600; // 30 giorni

# Diritti utenti

# The following permissions were set based on your choice in the installer
$wgGroupPermissions['*']['edit'] = false;
# Disabilita la possibilità di creare nuovi utenti da anonimi
$wgGroupPermissions['*']['createaccount'] = false;
# Inutile zapparci i piedi dato che la registrazione è ristretta.
$wgUseNPPatrol = false;
$wgUseRCPatrol = false;
$wgNoFollowLinks = false;
$wgNoFollowDomainExceptions[] = 'wikimedia.it';
$wgNoFollowDomainExceptions[] = 'openstreetmap.org';
$wgEnableScaryTranscluding = true;
$wgRestrictDisplayTitle = false;
# Non siamo molto disciplinati negli spostamenti di pagine.
$wgMaxRedirects = 3;

$wgGroupPermissions['Soci']['edit'] = true;
#$wgGroupPermissions['Soci']['editprotected'] = true;
$wgGroupPermissions['Collaboratori']['edit'] = true;
# Vecchio livello di protezione usato ai tempi di SimpleSecurity.
# Non ha più senso ma può essere ripristinato se necessario per sproteggere pagine.
#$wgRestrictionLevels[] = 'Direttivo';
#$wgGroupPermissions['Direttivo']['Direttivo'] = true;

# Abilita i segretari a creare account e a impostare i gruppi utente
# 2016-09-13 aggiunto noratelimits
# 2017-07-29 aggiunto ns Segreteria
$wgGroupPermissions['Segretari']['createaccount'] = true;
$wgGroupPermissions['Segretari']['noratelimit'] = true;
$wgGroupPermissions['Segretari']['renameuser'] = true;
$wgGroupPermissions['Ufficio']['noratelimit'] = true;
$wgAddGroups['Segretari'] = array( 'Soci', 'Collaboratori', 'Segretari', 'Ufficio' );
$wgRemoveGroups['Segretari'] = array( 'Soci', 'Collaboratori', 'Segretari', 'Ufficio' );

$wgGroupPermissions['Direttivo']['createaccount'] = true;
$wgAddGroups['Direttivo'] = array( 'Soci', 'Collaboratori', 'Direttivo', 'bureaucrat');
$wgRemoveGroups['Direttivo'] = array( 'Soci', 'Collaboratori', 'Direttivo', 'bureaucrat');

$wgGroupPermissions['*']['interwiki'] = false;
$wgGroupPermissions['sysop']['interwiki'] = true;
$wgGroupPermissions['Interwiki']['interwiki'] = true;
# 2016-06-13 richieste privacy.
$wgGroupPermissions['sysop']['deletelogentry'] = true;
$wgGroupPermissions['sysop']['deleterevision'] = true;

# since MediaWiki 1.31 only interface-admins as default can edit CSS
$wgGroupPermissions['sysop']['editsitecss'] = true;
$wgGroupPermissions['sysop']['editusercss'] = true;
$wgGroupPermissions['sysop']['editinterface'] = true;
$wgGroupPermissions['sysop']['editsitejs'] = true;
$wgGroupPermissions['sysop']['editsitecss'] = true;

# Aggiornato con pezza per T115333
$wgEnableAPI = false;

# Disabilita feed rss per sicurezza, aggirano l'ACL
$wgFeed = false;

# https://www.mediawiki.org/wiki/2021-12_security_release/FAQ
# Ridondante ma non dovrebbe guastare.
$wgActions['mcrundo'] = false;
$wgActions['mcrrestore'] = false;
$wgActions['rollback'] = false;
$wgWhitelistRead = [];
$wgWhitelistReadRegexp = [];

# Namespaces extra

$wgExtraNamespaces = array(
	100 => 'Associazione',
	101 => 'Discussioni_associazione',
	102 => 'Direttivo',
	103 => 'Discussioni_direttivo',
	114 => 'Ufficio',
	115 => 'Discussioni_ufficio',
/*	104 => 'CD',
	105 => 'Discussioni_CD',
	106 => 'Virgilio',
	107 => 'Discussioni_Virgilio',
	108 => 'Wikimania_2007',
	109 => 'Discussioni_Wikimania_2007',
	110 => 'IAL',
	111 => 'Discussioni_IAL',
	112 => 'Commissioni',
	113 => 'Discussioni_Commissioni'*/);

$wgNamespacesToBeSearchedDefault[100] = true;
$wgNamespacesToBeSearchedDefault[101] = true;

$wgNamespacesWithSubpages[0] = 1;
$wgNamespacesWithSubpages[100] = 1;
$wgNamespacesWithSubpages[101] = 1;
$wgNamespacesWithSubpages[102] = 1;
$wgNamespacesWithSubpages[103] = 1;
$wgNamespacesWithSubpages[114] = 1;
$wgNamespacesWithSubpages[115] = 1;
$wgExtraSignatureNamespaces = array( NS_MAIN, 100, 102 );

#Estensioni ammesse come upload

$wgFileExtensions = array( 'png', 'gif', 'jpg', 'jpeg', 'pdf', 'ogg', 'svg', # 'rtf',
        'odt', 'ods', 'odp', 'odg',                      # Open Document Format
#        'doc', 'ppt', #Micro$oft world :(
        'avi', 'mp3',
	'ico',
);

# Impostazione della dimensioni (temporali) di recentchanges
# imposto a 25 settimane (circa 6 mesi)
$wgRCMaxAge = 25 * 7 * 24 * 3600;

#abilita la modifica dei titoli delle pagine
$wgRestrictDisplayTitle = false;

#Abilita le funzioni stringa
$wgPFEnableStringFunctions = true;

// TODO: Probably these are related to [[Extension:SimpleSecurity]]
// that it'd disabled since many years, so probably this should be removed
// 2023-06-09 - Valerio Boz.
$wgSecurityExtraGroups = array(
    'Direttivo' => 'Membri del Direttivo',
    'Soci' => 'Soci dell\'associazione',
    'Collaboratori' => 'Collaboratori e dipendenti dell\'associazione',
    'Ufficio' => 'Dipendenti e altri che condividono con essi documenti riservati dell\'associazione',
);

# Prevent transclusion of a specific page.
# TODO: Deprecated in 1.36
#$wgHooks['BeforeParserFetchTemplateAndtitle'][] = function ( Parser $parser, $title, &$skip, &$id ) {
#	if ( $title->getArticleID() == 0 ) {
#		$skip = true;
#		$id = 1010851;
#		return false;
#	}
#};

# ??
# Delibere/2017/Conciliazione_con_ex_dipendente
# 2017-11-16: non rimuovere senza discutere con presidente e avvocato
$wgHooks['userCan'][] = function ( &$title, &$user, $action, &$result ) {
	if ( $title->getArticleID() == 53761 && !in_array( 'Soci', $user->getGroups() ) ) {
		$result = false;
		return false;
	}
};

# ??
# Delibere/2017/Conciliazione_con_ex_dipendente
$wgHooks['ShowSearchHit'][] = function ( $searchPage, $result, $terms, &$link, &$redirect, &$section, &$extract, &$score, &$size, &$date, &$related, &$html ) {
	if ( $result->getTitle()->getArticleID() == 53761 ) {
		$section = '';
		$extract = '';
		$size = '';
		$date = '';
		$related = '';
		$html = '';
		return false;
	}
};

#$wgReadOnly = 'Sito in manutenzione';

// migration from LockDown extension to MediaWiki core features

// as default, do not allow to read anything
$wgGroupPermissions['*']['read'] = false;

// but allo w to read from the default namespace
$wgWhitelistReadRegexp = [
	'/^[^:]*$/',     // main namespace
	'/^Categoria:/', // Categoria:
	'/^Category:/',  // Category:
	'/^File:/',      // File:
	'/^Template:/',  // Template
	'/^Utente:/',    // Utente:
	'/^User:/',      // User:
	'/^Speciale:PagineSpeciali/',

	// THESE CAN BE PROPOSED FOR ANON ABILITATION
	//	'/^Speciale:Ricerca/',
];

wfLoadExtension( 'Echo' ); // dependency of: Thanks
wfLoadExtension( 'Thanks' ); // useful to say "Thank you"
wfLoadExtension( 'Graph' ); // useful in combination with Scribunto to generate graphs
wfLoadExtension( 'VisualEditor' ); // useful to edit big tables

// allow advanced templates
wfLoadExtension( 'Scribunto' );
$wgScribuntoDefaultEngine = 'luastandalone';

// additional namespaces loving VisualEditor
$wgVisualEditorAvailableNamespaces = [
	'Associazione' => true,
	'Direttivo'    => true,
	'Segreteria'   => true,
];

// Parsoid does connections to the local MediaWiki server
wfLoadExtension( 'Parsoid', 'vendor/wikimedia/parsoid/extension.json' );
$wgVirtualRestConfig['modules']['parsoid'] = [
	// TODO: SSL encryption is useless for loopback connections
	// this could be updated to "http://" only if the webserver will accept loopback connections
	// without redirecting to "https://".
	'url' => 'https://wiki.wikimedia.it/rest.php',

	// this is a semi-private wiki and loopback connections needs original cookies to access pages
	'forwardCookies' => true,
];

$wgSMTP = [
	'host'     => 'mail.wikimedia.it',    // could also be an IP address. Where the SMTP server is located. If using SSL or TLS, add the prefix "ssl://" or "tls://".
	'IDHost'   => 'mail.wikimedia.it',    // Generally this will be the domain name of your website (aka mywiki.org)
	'port'     => 587,                    // Port to use when connecting to the SMTP server
	'auth'     => true,                   // Should we use SMTP authentication (true or false)

	// this secret configuration is stored in the LocalSettings-secret.php
	// 'username' => '<omissis>',
	// 'password' => '<omissis>',
];

// custom logs for troubleshooting
/*
$wgDBerrorLog = "$IP/../debug/dberror.log";
$wgDebugLogGroups = [
	'exception' => "$IP/../debug/exception.log",
	'error'     => "$IP/../debug/error.log",
];
*/

// load secret configurations
require "$IP/../LocalSettings-secret.php";
